/* ==============================================================================
   ==============================================================================
   =============         METAL SONIC 3.0 - VERSION 1.5            ===============
   =============              Spriting by Isaque                  ===============
   ==============================================================================
   =============     Scripting by CloneFighter, RubyTheMii        ===============
   =============              and Scarf the Wolf                  ===============
   ==============================================================================
   ============================================================================== */

freeslot("S_PLAY_NEGARISE", "S_PLAY_NEGAWAIT", "S_PLAY_NEGAFALL")
states[S_PLAY_NEGARISE] = {SPR_PLAY, SPR2_SPNG|A, 2, nil, 0, 0, S_PLAY_NEGARISE}
states[S_PLAY_NEGAWAIT] = {SPR_PLAY, SPR2_WAIT|A, 2, nil, 0, 0, S_PLAY_NEGAWAIT}
states[S_PLAY_NEGAFALL] = {SPR_PLAY, SPR2_FALL|A, 2, nil, 0, 0, S_PLAY_NEGAFALL}

//Air Burst and modified Hover.
addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "metalnega" and player.playerstate == PST_LIVE)
	and not (player.pflags & PF_THOKKED)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
	    player.drawangle = player.mo.angle
		if not CBW_Battle
			player.pflags = $|PF_THOKKED
			S_StartSound(player.mo, sfx_thok)
			S_StartSound(player.mo, sfx_cdfm62)
			local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok.state = S_FACESTABBERSPEAR
			thok.angle = player.drawangle+ANGLE_90
			thok.scale = player.mo.scale
			thok.fuse = 5
			thok.frame = $ & ~FF_TRANSMASK | TR_TRANS30
			thok.tics = 20
			thok.blendmode = AST_ADD
			thok.destscale = $*2
			thok.color = SKINCOLOR_PASTEL
			thok.colorized = true
			if (player.mo.eflags & MFE_UNDERWATER)
				P_Thrust(player.mo, player.mo.angle, 20*FRACUNIT)
			else
				P_Thrust(player.mo, player.mo.angle, 40*FRACUNIT)
			end
		else
			S_StartSound(mo, sfx_rail1)
			S_StartSound(mo, sfx_rail2)
			local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok.state = S_FACESTABBERSPEAR
			thok.angle = player.drawangle+ANGLE_90
			thok.scale = player.mo.scale
			thok.fuse = 5
			thok.frame = $ & ~FF_TRANSMASK | TR_TRANS30
			thok.tics = 20
			thok.blendmode = AST_ADD
			thok.destscale = $*2
			thok.color = SKINCOLOR_PASTEL
			thok.colorized = true
			if (player.mo.eflags & MFE_UNDERWATER)
				P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT/2)
			else
				P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
			end
		end
	end
end)

local function MetalSonic30(mo, trailmo, freq)
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = SKINCOLOR_PURPLE
        spawnedmo.blendmode = AST_ADD
		spawnedmo.frame = FF_TRANS50
		spawnedmo.destscale = 0
		spawnedmo.fuse = 4
    end
end

//Metal Sonic 3.0 Wait animation by Clone Fighter
freeslot("S_PARTICLE_MS30UP", "SPR_30PT")
states[S_PARTICLE_MS30UP] = {
    sprite = SPR_30PT,
    frame = FF_FULLBRIGHT|FF_ANIMATE|A,
    tics = 10,
    var1 = 3,
    var2 = 2,
    nextstate = S_NULL
}

-- Had to try to recreate the vanilla hover ability for this.
-- Worked out pretty well, though! ~RubyTheMii
addHook("PlayerThink", function(player)
   player.nega_hasfallen = $ or false
   if player.mo and player.mo.skin == "metalnega" then
	  if player.isxmomentum or player.xmomtoggledoff == false then
		 if player.pflags & PF_THOKKED then
			player.spcanflip = false
		 else
			player.spcanflip = true
		 end
	  end
	  -- A slight moveset tweak - roll when falling.
	  if not (P_PlayerInPain(player) or player.playerstate == PST_DEAD or player.playerstate == PST_REBORN or player.mo.state == S_PLAY_NEGARISE or player.mo.state == S_PLAY_NEGAWAIT or player.mo.state == S_PLAY_NEGAFALL) then
	     if (player.mo.state != S_PLAY_ROLL and not P_IsObjectOnGround(player.mo) and player.pflags & PF_JUMPED == 0) or player.mo.eflags & MFE_SPRUNG then
	        player.mo.state = S_PLAY_ROLL
	     end
	  end
	  if player.playerstate == PST_DEAD and player.mo.state != S_PLAY_DEAD then
	     player.mo.state = S_PLAY_DEAD
	  end
	  -- Now the rest.
	  if not (player.exiting or P_PlayerInPain(player) or player.playerstate == PST_DEAD or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL) then
		 if player.pflags & PF_THOKKED then
			if player.pflags & PF_JUMPDOWN then
			   if (player.dashmode >= 3*TICRATE) then
			      if FixedHypot(player.mo.momx, player.mo.momy) >= 28*FRACUNIT then
				     player.mo.state = S_PLAY_DASH
				  else
				     player.mo.state = S_PLAY_FLOAT
				  end
			   else
				  if FixedHypot(player.mo.momx, player.mo.momy) >= 24*FRACUNIT then
					 player.mo.state = S_PLAY_FLOAT_RUN
				  else
					 player.mo.state = S_PLAY_FLOAT
				  end
			   end
			   player.mo.momz = 0
			else 
			   if not (player.powers[pw_carry] or player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo) or player.powers[pw_justsprung] or player.mo.eflags & MFE_SPRUNG) then
				  player.mo.state = S_PLAY_NEGAFALL
			   end
			end
		 end
	  end
   else
      if (player.mo.state == S_PLAY_NEGARISE or player.mo.state == S_PLAY_NEGAWAIT) then
	     player.mo.flags = $&~MF_NOGRAVITY; player.waiting = 0; player.mo.state = S_PLAY_FALL
		 if player.mo.jetfume and player.mo.jetfume.valid then
			P_RemoveMobj(player.mo.jetfume); player.mo.jetfume = nil
		 end
	  end
   end
   if player.mo and player.mo.skin == "metalnega" then
      if player.waiting and player.waiting > 0 and (P_PlayerInPain(player) or player.playerstate == PST_DEAD) then
      	 player.waiting = 0; player.mo.flags = $&~MF_NOGRAVITY
	     if player.mo.jetfume and player.mo.jetfume.valid then
		    P_RemoveMobj(player.mo.jetfume); player.mo.jetfume = nil
	     end
	  end
	  if player.dashmode >= 3*TICRATE then
		 local metalnega_aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
		 metalnega_aura.color = SKINCOLOR_PASTEL
		 metalnega_aura.colorized = true
		 metalnega_aura.blendmode = AST_ADD
		 local metalnegaelectric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
		 metalnegaelectric.color = SKINCOLOR_PASTEL
		 metalnegaelectric.colorized = true
		 metalnegaelectric.blendmode = AST_ADD
		 metalnegaelectric.state = S_WATERZAP
		 MetalSonic30(player.mo, MT_THOK, 4*FRACUNIT)
		 if (leveltime % 24 == 0) then
			local thok2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok2.state = S_FACESTABBERSPEAR
			thok2.scale = player.mo.scale/2+FRACUNIT/4
			if FixedHypot(player.mo.momx, player.mo.momy) <= 28*FRACUNIT then
			   P_SetOrigin(thok2, player.mo.x, player.mo.y, player.mo.z+player.height/2)
			   thok2.renderflags = $|RF_FLOORSPRITE
			   thok2.destscale = $*4
			else
			   thok2.angle = player.drawangle+ANGLE_90
               thok2.destscale = $*2
			end
			thok2.fuse = 8
			thok2.color = SKINCOLOR_PURPLE
			thok2.colorized = true
			thok2.blendmode = AST_ADD
		 end
	  end
	  if player.mo.eflags & MFE_UNDERWATER then
		 player.powers[pw_underwater] = -1
	  elseif not P_InSpaceSector(player.mo) then
	     player.powers[pw_spacetime] = 20*TICRATE
	  end
	  if player.dashmode >= 3*TICRATE and (player.pflags & PF_THOKKED and player.pflags & PF_JUMPDOWN) then
		 player.dashmode = 4*TICRATE
	  end
	  -- Something extra for XMomentum.
	  if player.isxmomentum or player.xmomtoggledoff == false then
		 if player.mo.state == S_PLAY_FACEPLANT then
		    if S_SoundPlaying(player.mo, sfx_kc46)
			   S_StartSound(player.mo, sfx_fizzle)
			   S_StopSoundByID(player.mo, sfx_kc46)
		    end
		    if P_RandomChance(FRACUNIT/50) then
			   S_StartSound(player.mo, sfx_s3k5c)
			   player.mo.color = SKINCOLOR_WHITE
			   if not player.powers[pw_underwater] then
			      local spark = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-30, 30)*FRACUNIT, P_RandomRange(-30, 30)*FRACUNIT, P_RandomRange(0, 12)*FRACUNIT, MT_PARTICLE)
			      spark.state = S_WATERZAP
			      spark.tics = 5
			   end
		    else
			   player.mo.color = SKINCOLOR_COPYBOT
		    end
		 end
	  end
   end
   -- A custom color script for singleplayer XMomentum. ~RubyTheMii
   if player.mo and player.mo.skin == "metalnega" and not (multiplayer or netgame) then
	  if player.isxmomentum or player.xmomtoggledoff == false
	  and not (player.powers[pw_super] or player.powers[pw_shield] == SH_FIREFLOWER) then
		 player.mo.color = SKINCOLOR_COPYBOT
	  end
   end
   if not player.mo or not player.mo.valid or player.mo.skin != "metalnega" or P_PlayerInPain(player) or player.playerstate == PST_DEAD then return end
   if player.mo.state == S_PLAY_WAIT then
	  player.waiting = $ or 1
   end
   if player.waiting then
	  player.mo.jetfume = $ or P_SpawnMobjFromMobj(player.mo, -16*cos(player.drawangle), -16*sin(player.drawangle), 2*player.mo.height/5, MT_METALJETFUME)
	  player.mo.jetfume.state = (player.waiting <= 2) and S_JETFUMEFLASH or S_JETFUME1
	  player.mo.jetfume.frame = (player.waiting == 1) and D or (player.waiting == 2) and E
	  or (player.waiting%3 == 0) and C or (player.waiting%3 == 2) and B or A
	  player.mo.jetfume.scale = (player.waiting <= 2) and FRACUNIT or 2*FRACUNIT/5
	  P_SetOrigin(player.mo.jetfume, player.mo.x-16*cos(player.drawangle), player.mo.y-16*sin(player.drawangle), player.mo.z+2*player.mo.height/5)
	  if player.waiting < 15 then
		 if player.waiting == 1 then S_StartSound(player.mo, sfx_beflap) end
		    player.drawangle = player.mo.angle+FixedAngle(ease.outsine(player.waiting*FRACUNIT/14, 0, 360*FRACUNIT))
			player.mo.flags = $|MF_NOGRAVITY
			P_SetObjectMomZ(player.mo, ease.outsine(player.waiting*FRACUNIT/14, 10*FRACUNIT, 0))
			player.mo.state = S_PLAY_NEGARISE
			if leveltime&1 then
			   local a = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-32,32)*FRACUNIT, P_RandomRange(-32,32)*FRACUNIT, P_RandomRange(-10,56)*FRACUNIT, MT_PARTICLE)
			   a.state = S_PARTICLE_MS30UP
			   P_SetObjectMomZ(a, 5*FRACUNIT)
		       a.color = SKINCOLOR_RUBY
			end
			if player.waiting == 14 then
			   player.startz = player.mo.z
			end
		 else
			if player.mo.state != S_PLAY_NEGAWAIT then player.mo.state = S_PLAY_NEGAWAIT end
			player.mo.z = 3*sin(FixedAngle(ease.linear(player.waiting*FRACUNIT/80, 0, 360*FRACUNIT)))+player.startz
			local a = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-16,16)*FRACUNIT, P_RandomRange(-16,16)*FRACUNIT, P_RandomRange(-5,40)*FRACUNIT, MT_PARTICLE)
			a.state = S_WATERZAP
		 end
		 player.mo.momx,player.mo.momy = 0,0
		 player.waiting = $+1
		 if player.cmd.sidemove or player.cmd.forwardmove or (player.cmd.buttons & (BT_JUMP|BT_SPIN))
		 or player.mo.negadash or player.mo.negajump or (player.mo.ceilingz <= player.mo.z+player.height) then
			player.waiting = 0; player.mo.state = S_PLAY_NEGAFALL
			player.mo.flags = $ & ~MF_NOGRAVITY
			P_RemoveMobj(player.mo.jetfume)
			player.mo.jetfume = nil
		 end
	  end
	  if player.mo.state == S_PLAY_NEGAWAIT then
	     if player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo) then
	        player.waiting = 0; P_SetOrigin(player.mo, player.mo.x, player.mo.y, player.mo.floorz); player.mo.flags = $ & ~MF_NOGRAVITY; player.mo.state = S_PLAY_STND
			if player.mo.jetfume and player.mo.jetfume.valid then
			   P_RemoveMobj(player.mo.jetfume); player.mo.jetfume = nil
			end
		 end
	  end
end)

-- Fixing not spawning on the floor AND being in the wait animation in the next stage...
addHook("PlayerSpawn", function(player)
   if player.mo and player.mo.skin == "metalnega" then
      if player.waiting and player.waiting > 0 then
	     player.waiting = 0; P_SetOrigin(player.mo, player.mo.x, player.mo.y, player.mo.floorz); player.mo.flags = $ & ~MF_NOGRAVITY; player.mo.state = S_PLAY_STND
	  end
   end
end)
addHook("PlayerCanDamage", function(player)
   if player.mo and player.mo.skin == "metalnega" and player.nega_hasfallen == true then return true end
end)
addHook("MobjDamage", function(t, i)
   if t and t.valid and i and i.player and i.valid and i.skin == "metalnega" then
      if i.player.pflags & PF_THOKKED and i.player.dashmode < 3*TICRATE then
	     i.state = S_PLAY_ROLL; i.player.pflags = $ & ~PF_JUMPED|PF_THOKKED
	  end
   end
end)
